unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, ActnList, StdActns, Menus;

type
  TForm2 = class(TForm)
    Panel1: TPanel;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Edit1: TEdit;
    Memo1: TMemo;
    CheckBox1: TCheckBox;
    RadioButton1: TRadioButton;
    Button1: TButton;
    ProgressBar1: TProgressBar;
    StatusBar1: TStatusBar;
    DateTimePicker1: TDateTimePicker;
    TrackBar1: TTrackBar;
    RadioButton2: TRadioButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    ActionList1: TActionList;
    FileExit1: TFileExit;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    btnShellExecuteBackground: TButton;
    btnShellExecute: TButton;
    Memo2: TMemo;
    Virtualization: TTabSheet;
    Memo3: TMemo;
    edtIniValue: TEdit;
    Label2: TLabel;
    btnIniGet: TButton;
    btnIniSet: TButton;
    TabSheet2: TTabSheet;
    Button2: TButton;
    btnShield: TButton;
    Memo4: TMemo;
    TabSheetReadMe: TTabSheet;
    Memo5: TMemo;
    TimerDoRunAsAdmin: TTimer;
    procedure TrackBar1Change(Sender: TObject);
    procedure btnShellExecuteBackgroundClick(Sender: TObject);
    procedure btnShellExecuteClick(Sender: TObject);
    procedure btnIniGetClick(Sender: TObject);
    procedure btnIniSetClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure btnShieldClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TimerDoRunAsAdminTimer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

uses
  IniFiles, ShellAPI;

{$R *.dfm}

// Vista Utilities

procedure RunAsAdmin(hWnd: HWND; aFile: string; aParameters: string);
var
  sei: TShellExecuteInfoA;
begin
  FillChar(sei, SizeOf(sei), 0);
  sei.cbSize := sizeof(sei);
  sei.Wnd := hWnd;
  sei.fMask := SEE_MASK_FLAG_DDEWAIT or SEE_MASK_FLAG_NO_UI;
  sei.lpVerb := 'runas';
  sei.lpFile := PChar(aFile);
  sei.lpParameters := PChar(aParameters);
  sei.nShow := SW_SHOWNORMAL;
  if not ShellExecuteEx(@sei) then
    RaiseLastOSError;
end;

const
  BCM_FIRST = $1600; // Button control messages
  BCM_SETSHIELD = BCM_FIRST + $000C;

procedure SetElevationRequiredState(aControl: TWinControl; Requiered: Boolean);
var
  lRequired: Integer;
begin
  lRequired := Integer(Requiered);
  SendMessage(aControl.Handle, BCM_SETSHIELD, 0, lRequired);
end;

procedure TForm2.btnIniSetClick(Sender: TObject);
var
  Ini: TCustomIniFile;
begin
  //Write to INI-file. Will create shadow in virtual store depending on manifest.
  //Running with execution level AsInvoker (User) will create access denied exception.
  Ini := TIniFile.Create(ExtractFilePath(Application.ExeName)+'/TestSettings.ini');
  Ini.WriteString('Option','Value',edtIniValue.Text);
end;

procedure TForm2.btnShellExecuteBackgroundClick(Sender: TObject);
begin
  //Minimize application and enable Timer to trigger elevation in background.
  ShowMessage('Close this dialog and then press Ctrl+Tab to switch focus to another application. '+
              'Notice the flashing button on the task bar that appears after a few seconds when the timer calls ShellExecute.');
  TimerDoRunAsAdmin.Enabled := True;
end;

procedure TForm2.TimerDoRunAsAdminTimer(Sender: TObject);
begin
  TimerDoRunAsAdmin.Enabled := False;
  //With a handle to a window, consent dialog will be delayed in Task Bar if app is minimized
  RunAsAdmin(Application.MainFormHandle, 'notepad.exe', '');
end;

procedure TForm2.btnShellExecuteClick(Sender: TObject);
begin
  //Without a handle to a foreground window consent windows will appear in Task Bar
  RunAsAdmin(0, 'notepad.exe', '');
end;

procedure TForm2.Button2Click(Sender: TObject);
var
  Stream: TFileStream;
begin
  Stream := TFileStream.Create(ExtractFilePath(Application.ExeName)+'/TestSettings.ini',fmOpenReadWrite);
  Memo3.Lines.LoadFromStream(Stream);
  Stream.Free;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  PageControl1.ActivePage := TabSheetReadMe;
end;

procedure TForm2.btnShieldClick(Sender: TObject);
begin
  SetElevationRequiredState(btnShield, True);
end;

procedure TForm2.btnIniGetClick(Sender: TObject);
var
  Ini: TCustomIniFile;
begin
  //Read from INI-file. Value can come from real file or shadow in virtual store depending on manifest.
  Ini := TIniFile.Create(ExtractFilePath(Application.ExeName)+'/TestSettings.ini');
  edtIniValue.Text := Ini.ReadString('Option','Value','');
end;


procedure TForm2.TrackBar1Change(Sender: TObject);
begin
  ProgressBar1.Position := TrackBar1.Position;
end;

end.
