program VistaConsoleApplication;

{$APPTYPE CONSOLE}

//Include Manifest with trustinfo to make executable Vista Logo Compliant and not run in compatibility mode.
//Console Applications should always run as invoker even if they require admin privileges.
{$R 'ExecutionLevelAsInvokerManifest.res' 'ExecutionLevelAsInvokerManifest.rc'}

uses
  SysUtils,
  UserAccessControlUtils in 'UserAccessControlUtils.pas';

begin
  try

    case GetTokenElevationType of
      TokenElevationNotAvailable:
        WriteLn('No information about elevation is available.');
      TokenElevationTypeDefault:
        WriteLn('TokenElevationTypeDefault - User is not using a split token.');
      TokenElevationTypeFull:
        WriteLn('TokenElevationTypeFull - User has a split token, and the process is running elevated.');
      TokenElevationTypeLimited:
        WriteLn('TokenElevationTypeLimited - User has a split token, but the process is not running elevated.');
    end;

    RequireAdminConsole;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
